2009-12-05 20:55:00 +00:00
# The shell is commented out so that it will run in bash on linux and ksh on aix
# !/bin/bash
# Build and upload the xcat-core code, on either linux or aix.
2009-02-23 21:03:18 +00:00
2009-11-06 16:11:05 +00:00
# Getting Started:
# - Check out the xcat-core svn repository (either the trunk or a branch) into
# a dir called <rel>/src/xcat-core, where <rel> is the same as the release dir it will be
# uploaded to in sourceforge (e.g. devel, or 2.3).
# - You probably also want to put root's pub key from the build machine onto sourceforge for
# the upload user listed below, so you don't have to keep entering pw's. You can do this
2009-11-06 16:38:13 +00:00
# at https://sourceforge.net/account/ssh
2009-12-05 20:55:00 +00:00
# - On Linux: make sure createrepo is installed on the build machine
2011-08-25 19:54:25 +00:00
# - On AIX: Install openssl and openssh installp pkgs and run updtvpkg. Install from http://www.perzl.org/aix/ :
2009-12-05 20:55:00 +00:00
# apr, apr-util, bash, bzip2, db4, expat, gdbm, gettext, glib2, gmp, info, libidn, neon, openssl (won't
2011-08-25 19:54:25 +00:00
# conflict with the installp version - but i don't think you need this), pcre, perl-DBD-SQLite, perl-DBI,
# popt, python, readline, rsynce, sqlite, subversion, unixODBC, zlib. Install wget from http://www-03.ibm.com/systems/power/software/aix/linux/toolbox/alpha.html
2009-11-06 19:26:12 +00:00
# - Run this script from the local svn repository you just created. It will create the other
# directories that are needed.
2009-02-23 21:03:18 +00:00
2009-07-31 20:36:29 +00:00
# Usage: buildcore.sh [attr=value attr=value ...]
# PROMOTE=1 - if the attribute "PROMOTE" is specified, means an official dot release.
2009-02-26 21:48:23 +00:00
# Otherwise, and snap build is assumed.
2010-09-22 13:18:13 +00:00
# PREGA=1 - means this is a branch that has not been released yet, so during the promote, copy the
# xcat-core tarball to the SF web site instead of the FRS area.
2009-07-31 20:36:29 +00:00
# UP=0 or UP=1 - override the default upload behavior
# SVNUP=<filename> - control which rpms get built by specifying a coresvnup file
2011-12-27 10:44:55 +00:00
# FRSYUM=0 - put the yum repo and snap builds in the old project web area instead of the FRS area.
2011-12-19 17:01:18 +00:00
# VERBOSE=1 - to see lots of verbose output
2009-02-26 21:48:23 +00:00
2009-02-23 21:03:18 +00:00
# you can change this if you need to
UPLOADUSER = bp-sawyers
2011-12-19 17:01:18 +00:00
FRS = /home/frs/project/x/xc/xcat
2009-02-23 21:03:18 +00:00
2011-12-19 17:01:18 +00:00
# Process cmd line variable assignments, assigning each attr=val pair to a variable of same name
for i in $* ; do
2011-12-21 12:21:31 +00:00
# upper case the variable name
varstring = ` echo " $i " | cut -d '=' -f 1| tr [ a-z] [ A-Z] ` = ` echo " $i " | cut -d '=' -f 2`
export $varstring
2011-12-19 17:01:18 +00:00
done
if [ " $VERBOSE " = "1" -o " $VERBOSE " = "yes" ] ; then
set -x
VERBOSEMODE = 1
fi
2009-12-05 20:55:00 +00:00
2011-12-19 17:01:18 +00:00
# Find where this script is located to set some build variables
2010-04-23 19:29:08 +00:00
cd ` dirname $0 `
2011-12-19 17:01:18 +00:00
# strip the /src/xcat-core from the end of the dir to get the next dir up and use as the release
2011-12-22 10:56:44 +00:00
if [ -z " $REL " ] ; then
2011-12-19 17:01:18 +00:00
curdir = ` pwd `
D = ${ curdir %/src/xcat-core }
REL = ` basename $D `
fi
OSNAME = $( uname)
2010-04-23 19:29:08 +00:00
2010-04-16 14:37:03 +00:00
if [ " $OSNAME " != "AIX" ] ; then
2009-12-05 20:55:00 +00:00
GSA = http://pokgsa.ibm.com/projects/x/xcat/build/linux
2010-04-23 19:29:08 +00:00
# Get a lock, so can not do 2 builds at once
exec 8>/var/lock/xcatbld-$REL .lock
2010-04-23 19:33:19 +00:00
if ! flock -n 8; then
2010-04-23 19:29:08 +00:00
echo " Can't get lock /var/lock/xcatbld- $REL .lock. Someone else must be doing a build right now. Exiting.... "
exit 1
fi
2011-12-19 17:01:18 +00:00
export HOME = /root # This is so rpm and gpg will know home, even in sudo
2009-12-05 20:55:00 +00:00
fi
2009-11-06 20:53:22 +00:00
2011-12-19 17:01:18 +00:00
# this is needed only when we are transitioning the yum over to frs
2011-12-27 10:44:55 +00:00
if [ " $FRSYUM " != 0 ] ; then
2011-12-19 17:01:18 +00:00
YUMDIR = $FRS
YUMREPOURL = "https://sourceforge.net/projects/xcat/files/yum"
else
YUMDIR = htdocs
YUMREPOURL = "http://xcat.sourceforge.net/yum"
2009-12-07 14:40:27 +00:00
fi
2009-05-08 16:31:57 +00:00
2011-12-19 17:01:18 +00:00
# Set variables based on which type of build we are doing
XCATCORE = "xcat-core" # core-snap is a sym link to xcat-core
echo "svn --quiet up Version"
svn --quiet up Version
2009-01-28 15:42:14 +00:00
VER = ` cat Version`
2009-12-23 11:54:00 +00:00
SHORTVER = ` cat Version| cut -d. -f 1,2`
2010-04-19 13:30:22 +00:00
SHORTSHORTVER = ` cat Version| cut -d. -f 1`
2009-07-31 20:36:29 +00:00
if [ " $PROMOTE " = 1 ] ; then
2009-04-07 00:43:03 +00:00
CORE = "xcat-core"
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
TARNAME = core-aix-$VER .tar.gz
else
TARNAME = xcat-core-$VER .tar.bz2
fi
2009-04-07 00:43:03 +00:00
else
CORE = "core-snap"
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
TARNAME = core-aix-snap.tar.gz
else
TARNAME = core-rpms-snap.tar.bz2
fi
2009-04-07 00:43:03 +00:00
fi
2009-10-08 20:17:51 +00:00
DESTDIR = ../../$XCATCORE
2009-11-06 16:11:05 +00:00
SRCD = core-snap-srpms
2009-04-07 00:43:03 +00:00
2009-04-17 14:25:21 +00:00
2009-07-31 20:36:29 +00:00
if [ " $PROMOTE " != 1 ] ; then # very long if statement to not do builds if we are promoting
2009-04-07 00:43:03 +00:00
mkdir -p $DESTDIR
2009-11-06 16:11:05 +00:00
SRCDIR = ../../$SRCD
2009-04-07 00:43:03 +00:00
mkdir -p $SRCDIR
2011-12-19 17:01:18 +00:00
if [ -n " $VERBOSEMODE " ] ; then
GREP = grep
else
GREP = "grep -q"
fi
# currently aix builds ppc rpms, but someday it should build noarch
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
NOARCH = ppc
else
NOARCH = noarch
fi
2008-03-04 18:10:05 +00:00
UPLOAD = 0
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
source = /opt/freeware/src/packages
2008-03-04 18:10:05 +00:00
else
2011-12-19 17:01:18 +00:00
source = ` rpmbuild --eval '%_topdir' xCATsn/xCATsn.spec`
if [ $? -gt 0 ] ; then
echo "Error: Could not determine rpmbuild's root directory."
exit 2
2009-12-05 20:55:00 +00:00
fi
2011-12-19 17:01:18 +00:00
#echo "source=$source"
2008-03-04 18:10:05 +00:00
fi
2009-11-06 16:11:05 +00:00
# If they have not given us a premade update file, do an svn update and capture the results
2009-05-08 15:09:15 +00:00
if [ -z " $SVNUP " ] ; then
SVNUP = ../coresvnup
2011-12-19 17:01:18 +00:00
echo " svn up > $SVNUP "
2009-05-08 15:09:15 +00:00
svn up > $SVNUP
2009-05-11 14:35:46 +00:00
fi
2009-11-06 16:11:05 +00:00
2009-12-23 11:09:48 +00:00
# If anything has changed, we should always rebuild perl-xCAT
if ! $GREP 'At revision' $SVNUP ; then # Use to be: $GREP perl-xCAT $SVNUP; then
2011-12-19 17:01:18 +00:00
UPLOAD = 1
./makerpm perl-xCAT
if [ $? -ne 0 ] ; then
FAILEDRPMS = "perl-xCAT"
else
rm -f $DESTDIR /perl-xCAT*rpm
rm -f $SRCDIR /perl-xCAT*rpm
mv $source /RPMS/$NOARCH /perl-xCAT-$VER *rpm $DESTDIR /
mv $source /SRPMS/perl-xCAT-$VER *rpm $SRCDIR /
fi
2009-12-23 11:09:48 +00:00
fi
if [ " $OSNAME " = "AIX" ] ; then
2010-01-11 23:25:00 +00:00
# For the 1st one we overwrite, not append
2010-04-19 13:57:55 +00:00
echo " rpm -Uvh perl-xCAT- $SHORTSHORTVER *rpm " > $DESTDIR /instxcat
2009-05-08 15:09:15 +00:00
fi
2009-01-28 15:42:14 +00:00
2011-12-19 17:01:18 +00:00
# Build the rest of the noarch rpms
for rpmname in xCAT-client xCAT-server xCAT-IBMhpc xCAT-rmc xCAT-UI xCAT-test; do
if $GREP $rpmname $SVNUP ; then
UPLOAD = 1
./makerpm $rpmname
if [ $? -ne 0 ] ; then
FAILEDRPMS = " $FAILEDRPMS $rpmname "
else
rm -f $DESTDIR /$rpmname *rpm
rm -f $SRCDIR /$rpmname *rpm
mv $source /RPMS/$NOARCH /$rpmname -$VER *rpm $DESTDIR /
mv $source /SRPMS/$rpmname -$VER *rpm $SRCDIR /
fi
fi
if [ " $OSNAME " = "AIX" ] ; then
if [ " $rpmname " = "xCAT-client" -o " $rpmname " = "xCAT-server" ] ; then # we do not automatically install the rest of the rpms on AIX
echo " rpm -Uvh $rpmname - $SHORTSHORTVER *rpm " >> $DESTDIR /instxcat
fi
fi
done
2010-09-21 14:28:10 +00:00
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " != "AIX" ] ; then
if $GREP xCAT-nbroot $SVNUP ; then
2011-12-19 17:01:18 +00:00
UPLOAD = 1
ORIGFAILEDRPMS = " $FAILEDRPMS "
for arch in x86_64 x86 ppc64; do
./makerpm xCAT-nbroot-core $arch
if [ $? -ne 0 ] ; then FAILEDRPMS = " $FAILEDRPMS xCAT-nbroot-core- $arch " ; fi
done
2011-12-22 01:32:48 +00:00
if [ " $FAILEDRPMS " = " $ORIGFAILEDRPMS " ] ; then # all succeeded
2011-12-19 17:01:18 +00:00
rm -f $DESTDIR /xCAT-nbroot-core*rpm
rm -f $SRCDIR /xCAT-nbroot-core*rpm
mv $source /RPMS/noarch/xCAT-nbroot-core-*rpm $DESTDIR
mv $source /SRPMS/xCAT-nbroot-core-*rpm $SRCDIR
fi
2009-12-05 20:55:00 +00:00
fi
2008-03-18 20:02:53 +00:00
fi
2009-12-05 20:55:00 +00:00
2011-12-19 17:01:18 +00:00
# Build the xCAT and xCATsn rpms for all platforms
for rpmname in xCAT xCATsn; do
if $GREP -E " ^[UAD] + $rpmname / " $SVNUP ; then
UPLOAD = 1
ORIGFAILEDRPMS = " $FAILEDRPMS "
if [ " $OSNAME " = "AIX" ] ; then
./makerpm $rpmname
if [ $? -ne 0 ] ; then FAILEDRPMS = " $FAILEDRPMS $rpmname " ; fi
else
for arch in x86_64 i386 ppc64 s390x; do
./makerpm $rpmname $arch
if [ $? -ne 0 ] ; then FAILEDRPMS = " $FAILEDRPMS $rpmname - $arch " ; fi
done
fi
2011-12-22 01:32:48 +00:00
if [ " $FAILEDRPMS " = " $ORIGFAILEDRPMS " ] ; then # all succeeded
rm -f $DESTDIR /$rpmname -$SHORTSHORTVER *rpm
rm -f $SRCDIR /$rpmname -$SHORTSHORTVER *rpm
2011-12-19 17:01:18 +00:00
mv $source /RPMS/*/$rpmname -$VER *rpm $DESTDIR
mv $source /SRPMS/$rpmname -$VER *rpm $SRCDIR
fi
2009-12-05 20:55:00 +00:00
fi
2011-12-19 17:01:18 +00:00
done
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
2010-04-19 13:30:22 +00:00
echo " rpm -Uvh xCAT- $SHORTSHORTVER *rpm " >> $DESTDIR /instxcat
echo " rpm -Uvh xCAT-rmc- $SHORTSHORTVER *rpm " >> $DESTDIR /instxcat
2008-03-04 18:10:05 +00:00
fi
2009-02-26 21:48:23 +00:00
2009-11-12 14:35:24 +00:00
# Decide if anything was built or not
2011-12-19 17:01:18 +00:00
if [ -n " $FAILEDRPMS " ] ; then
echo " Error: build of the following RPMs failed: $FAILEDRPMS "
exit 2
fi
2009-11-13 23:09:13 +00:00
if [ $UPLOAD = = 0 -a " $UP " != 1 ] ; then
2009-11-12 14:35:24 +00:00
echo "Nothing new detected"
2011-12-19 17:01:18 +00:00
exit 0
2008-03-04 18:10:05 +00:00
fi
2009-11-12 14:35:24 +00:00
#else we will continue
2009-02-26 21:48:23 +00:00
# Prepare the RPMs for pkging and upload
2009-12-05 20:55:00 +00:00
2009-11-06 20:53:22 +00:00
# get gpg keys in place
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " != "AIX" ] ; then
mkdir -p $HOME /.gnupg
for i in pubring.gpg secring.gpg trustdb.gpg; do
if [ ! -f $HOME /.gnupg/$i ] || [ ` wc -c $HOME /.gnupg/$i | cut -f 1 -d' ' ` = = 0 ] ; then
rm -f $HOME /.gnupg/$i
wget -P $HOME /.gnupg $GSA /keys/$i
chmod 600 $HOME /.gnupg/$i
fi
done
# tell rpm to use gpg to sign
MACROS = $HOME /.rpmmacros
2011-12-19 17:01:18 +00:00
if ! $GREP '%_signature gpg' $MACROS 2>/dev/null; then
2009-12-05 20:55:00 +00:00
echo '%_signature gpg' >> $MACROS
fi
2011-12-19 17:01:18 +00:00
if ! $GREP '%_gpg_name' $MACROS 2>/dev/null; then
2009-12-05 20:55:00 +00:00
echo '%_gpg_name Jarrod Johnson' >> $MACROS
fi
2011-12-21 12:21:31 +00:00
echo "Signing RPMs..."
2011-12-22 10:56:44 +00:00
build-utils/rpmsign.exp $DESTDIR /*rpm | grep -v -E '(was already signed|rpm --quiet --resign|WARNING: standard input reopened)'
build-utils/rpmsign.exp $SRCDIR /*rpm | grep -v -E '(was already signed|rpm --quiet --resign|WARNING: standard input reopened)'
2009-12-05 20:55:00 +00:00
createrepo $DESTDIR
createrepo $SRCDIR
rm -f $SRCDIR /repodata/repomd.xml.asc
rm -f $DESTDIR /repodata/repomd.xml.asc
gpg -a --detach-sign $DESTDIR /repodata/repomd.xml
gpg -a --detach-sign $SRCDIR /repodata/repomd.xml
if [ ! -f $DESTDIR /repodata/repomd.xml.key ] ; then
wget -P $DESTDIR /repodata $GSA /keys/repomd.xml.key
fi
if [ ! -f $SRCDIR /repodata/repomd.xml.key ] ; then
wget -P $SRCDIR /repodata $GSA /keys/repomd.xml.key
2009-11-06 20:53:22 +00:00
fi
2009-11-06 20:08:25 +00:00
fi
2009-12-05 20:55:00 +00:00
2009-11-06 16:11:05 +00:00
# make everything have a group of xcat, so anyone can manage them once they get on SF
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
2011-12-19 17:01:18 +00:00
if ! lsgroup xcat >/dev/null 2>& 1; then
mkgroup xcat
fi
2009-12-05 20:55:00 +00:00
chmod +x $DESTDIR /instxcat
2011-12-19 17:01:18 +00:00
else # linux
if ! $GREP xcat /etc/group; then
groupadd xcat
fi
2009-12-05 20:55:00 +00:00
fi
2009-02-23 21:03:18 +00:00
chgrp -R xcat $DESTDIR
chmod -R g+w $DESTDIR
2009-11-06 16:11:05 +00:00
chgrp -R xcat $SRCDIR
chmod -R g+w $SRCDIR
2010-04-16 14:37:03 +00:00
2009-04-07 00:43:03 +00:00
fi # end of very long if-not-promote
2009-04-17 14:25:21 +00:00
cd $DESTDIR
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " != "AIX" ] ; then
# Modify the repo file to point to either xcat-core or core-snap
# Always recreate it, in case the whole dir was copied from devel to 2.x
cat >xCAT-core.repo << EOF
2009-11-06 16:38:13 +00:00
[ xcat-2-core]
name = xCAT 2 Core packages
2011-12-19 17:01:18 +00:00
baseurl = $YUMREPOURL /$REL /$CORE
2009-11-06 16:38:13 +00:00
enabled = 1
gpgcheck = 1
2011-12-19 17:01:18 +00:00
gpgkey = $YUMREPOURL /$REL /$CORE /repodata/repomd.xml.key
2009-11-06 16:38:13 +00:00
EOF
2009-12-05 20:55:00 +00:00
# Create the mklocalrepo script
cat >mklocalrepo.sh << 'EOF2'
2009-11-13 23:09:13 +00:00
#!/bin/sh
cd ` dirname $0 `
REPOFILE = ` basename xCAT-*.repo`
2010-05-05 19:41:16 +00:00
sed -e 's|baseurl=.*|baseurl=file://' "`pwd`" '|' $REPOFILE | sed -e 's|gpgkey=.*|gpgkey=file://' "`pwd`" '/repodata/repomd.xml.key|' > /etc/yum.repos.d/$REPOFILE
2009-11-13 23:09:13 +00:00
cd -
EOF2
2010-03-19 16:54:56 +00:00
chmod 775 mklocalrepo.sh
fi # not AIX
2009-04-17 14:25:21 +00:00
# Build the tarball
2009-05-08 15:09:15 +00:00
cd ..
2011-12-19 17:01:18 +00:00
if [ -n " $VERBOSEMODE " ] ; then
2011-12-22 10:56:44 +00:00
verboseflag = "-v"
2011-12-19 17:01:18 +00:00
else
2011-12-22 10:56:44 +00:00
verboseflag = ""
2011-12-19 17:01:18 +00:00
fi
echo " Creating $TARNAME ... "
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
2011-12-22 10:56:44 +00:00
tar $verboseflag -hcf ${ TARNAME %.gz } $XCATCORE
2009-12-05 20:55:00 +00:00
rm -f $TARNAME
gzip ${ TARNAME %.gz }
else
2011-12-22 10:56:44 +00:00
tar $verboseflag -hjcf $TARNAME $XCATCORE
2009-12-05 20:55:00 +00:00
fi
2009-04-07 00:43:03 +00:00
chgrp xcat $TARNAME
chmod g+w $TARNAME
2009-02-26 21:48:23 +00:00
2009-11-12 14:35:24 +00:00
# Decide whether to upload or not
if [ -n " $UP " ] && [ " $UP " = = 0 ] ; then
exit 0;
fi
#else we will continue
2009-07-31 20:36:29 +00:00
# Upload the individual RPMs to sourceforge
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " = "AIX" ] ; then
YUM = aix
else
YUM = yum
fi
2009-10-08 20:17:51 +00:00
if [ ! -e core-snap ] ; then
ln -s xcat-core core-snap
fi
2011-08-17 16:00:45 +00:00
if [ " $REL " = "devel" -o " $PREGA " != 1 ] ; then
2011-12-19 17:01:18 +00:00
i = 0
echo " Uploading RPMs from $CORE to $YUMDIR / $YUM / $REL / ... "
2011-12-22 13:53:53 +00:00
while [ $(( i += 1 )) -le 5 ] && ! rsync -urLv --delete $CORE $UPLOADUSER ,xcat@web.sourceforge.net:$YUMDIR /$YUM /$REL /
2011-08-17 16:00:45 +00:00
do : ; done
fi
2009-07-31 20:36:29 +00:00
2009-11-06 16:11:05 +00:00
# Upload the individual source RPMs to sourceforge
2011-12-19 17:01:18 +00:00
i = 0
echo " Uploading src RPMs from $SRCD to $YUMDIR / $YUM / $REL / ... "
2011-12-22 13:53:53 +00:00
while [ $(( i += 1 )) -le 5 ] && ! rsync -urLv --delete $SRCD $UPLOADUSER ,xcat@web.sourceforge.net:$YUMDIR /$YUM /$REL /
2009-11-06 16:11:05 +00:00
do : ; done
2009-07-31 20:36:29 +00:00
# Upload the tarball to sourceforge
2010-09-22 13:18:13 +00:00
if [ " $PROMOTE " = 1 -a " $REL " != "devel" -a " $PREGA " != 1 ] ; then
2009-04-16 20:01:54 +00:00
# upload tarball to FRS area
2011-12-19 17:01:18 +00:00
i = 0
echo " Uploading $TARNAME to $FRS /xcat/ $REL .x_ $OSNAME / ... "
2011-12-22 13:53:53 +00:00
while [ $(( i += 1 )) -le 5 ] && ! rsync -v $TARNAME $UPLOADUSER ,xcat@web.sourceforge.net:$FRS /xcat/$REL .x_$OSNAME /
2009-08-13 19:07:34 +00:00
do : ; done
2009-02-26 21:48:23 +00:00
else
2011-12-19 17:01:18 +00:00
i = 0
echo " Uploading $TARNAME to $YUMDIR / $YUM / $REL / ... "
2011-12-22 13:53:53 +00:00
while [ $(( i += 1 )) -le 5 ] && ! rsync -v $TARNAME $UPLOADUSER ,xcat@web.sourceforge.net:$YUMDIR /$YUM /$REL /
2009-07-31 20:36:29 +00:00
do : ; done
2009-02-26 21:48:23 +00:00
fi
2009-06-12 15:49:27 +00:00
# Extract and upload the man pages in html format
2009-12-05 20:55:00 +00:00
if [ " $OSNAME " != "AIX" -a " $REL " = "devel" -a " $PROMOTE " != 1 ] ; then
2011-12-22 10:56:44 +00:00
echo "Extracting and uploading man pages to htdocs/ ..."
2009-06-12 15:49:27 +00:00
mkdir -p man
cd man
rm -rf opt
2009-12-05 20:55:00 +00:00
rpm2cpio ../$XCATCORE /xCAT-client-*.$NOARCH .rpm | cpio -id '*.html'
rpm2cpio ../$XCATCORE /perl-xCAT-*.$NOARCH .rpm | cpio -id '*.html'
2010-09-28 14:45:44 +00:00
rpm2cpio ../$XCATCORE /xCAT-test-*.$NOARCH .rpm | cpio -id '*.html'
2011-12-19 17:01:18 +00:00
i = 0
2011-12-22 13:53:53 +00:00
while [ $(( i += 1 )) -le 5 ] && ! rsync $verboseflag -r opt/xcat/share/doc/man1 opt/xcat/share/doc/man3 opt/xcat/share/doc/man5 opt/xcat/share/doc/man7 opt/xcat/share/doc/man8 $UPLOADUSER ,xcat@web.sourceforge.net:htdocs/
2009-07-31 20:36:29 +00:00
do : ; done
2009-06-12 15:49:27 +00:00
cd ..
fi